| Fling Engine 0.00.1 Fling Engine is a game engine written in Vulkan

Public Member Functions | Protected Member Functions | Protected Attributes | Friends
Fling::BaseEditor Class Reference

The BaseEditor of the Fling Engine. More...

`#include <BaseEditor.h>`

Inherited by Sandbox::SandboxEditor.

## Public Member Functions
| BaseEditor ()=default
virtual | ~BaseEditor ()=default
virtual void | RegisterComponents (entt::registry &t_Reg)
| Register. More...
virtual void | Draw (entt::registry &t_Reg, float DeltaTime)
| Draws the editor via IMGUI. More...

## Protected Member Functions
virtual void | OnLoadLevel (std::string t_FileName)
virtual void | OnSaveLevel (std::string t_FileName)
virtual void | DrawFileMenu ()
void | DrawGpuInfo ()
void | DrawWorldOutline (entt::registry &t_Reg)
void | DrawWindowOptions ()

## Protected Attributes
std::array< float, 400 > | fpsGraph {}
float | m_FrameTimeMin = 9999.0f
float | m_FrameTimeMax = 0.0f
bool | m_DisplayGPUInfo = false
bool | m_DisplayComponentEditor = true
bool | m_DisplayWorldOutline = true
bool | m_DisplayWindowOptions = false
entt::entity | m_CompEditorEntityType = entt::null
| Component editor so that we can draw our component window. More...
MM::ImGuiEntityEditor< entt::registry > | m_ComponentEditor
class World * | m_OwningWorld = nullptr
class Game * | m_Game = nullptr

## Friends
class | Engine

## Detailed Description

The BaseEditor of the Fling Engine.

Draw and add any game specifc Editor UI tools here

## Constructor & Destructor Documentation

## ◆ BaseEditor()

Fling::BaseEditor::BaseEditor | ( |  | ) |
| default

## ◆ ~BaseEditor()

virtual Fling::BaseEditor::~BaseEditor | ( |  | ) |
| virtual default

## Member Function Documentation

## ◆ Draw()

virtual void Fling::BaseEditor::Draw | ( | entt::registry & | t_Reg,
|  | float | DeltaTime
| ) |  |
| virtual

Draws the editor via IMGUI.

Does NOT need to do any addition renderering pipeline things

Reimplemented in Sandbox::SandboxEditor.

## ◆ DrawFileMenu()

virtual void Fling::BaseEditor::DrawFileMenu | ( |  | ) |
| protected virtual

## ◆ DrawGpuInfo()

void Fling::BaseEditor::DrawGpuInfo | ( |  | ) |
| protected

## ◆ DrawWindowOptions()

void Fling::BaseEditor::DrawWindowOptions | ( |  | ) |
| protected

## ◆ DrawWorldOutline()

void Fling::BaseEditor::DrawWorldOutline | ( | entt::registry & | t_Reg | ) |
| protected

## ◆ OnLoadLevel()

virtual void Fling::BaseEditor::OnLoadLevel | ( | std::string | t_FileName | ) |
| protected virtual

Reimplemented in Sandbox::SandboxEditor.

## ◆ OnSaveLevel()

virtual void Fling::BaseEditor::OnSaveLevel | ( | std::string | t_FileName | ) |
| protected virtual

Reimplemented in Sandbox::SandboxEditor.

## ◆ RegisterComponents()

virtual void Fling::BaseEditor::RegisterComponents | ( | entt::registry & | t_Reg | ) |
| virtual

Register.

## Friends And Related Function Documentation

## ◆ Engine

friend class Engine
| friend

## Field Documentation

## ◆ fpsGraph

std::array<float, 400> Fling::BaseEditor::fpsGraph {}
| protected

## ◆ m_CompEditorEntityType

entt::entity Fling::BaseEditor::m_CompEditorEntityType = entt::null
| protected

Component editor so that we can draw our component window.

## ◆ m_ComponentEditor

MM::ImGuiEntityEditor<entt::registry> Fling::BaseEditor::m_ComponentEditor
| protected

## ◆ m_DisplayComponentEditor

bool Fling::BaseEditor::m_DisplayComponentEditor = true
| protected

## ◆ m_DisplayGPUInfo

bool Fling::BaseEditor::m_DisplayGPUInfo = false
| protected

## ◆ m_DisplayWindowOptions

bool Fling::BaseEditor::m_DisplayWindowOptions = false
| protected

## ◆ m_DisplayWorldOutline

bool Fling::BaseEditor::m_DisplayWorldOutline = true
| protected

## ◆ m_FrameTimeMax

float Fling::BaseEditor::m_FrameTimeMax = 0.0f
| protected

## ◆ m_FrameTimeMin

float Fling::BaseEditor::m_FrameTimeMin = 9999.0f
| protected

## ◆ m_Game

class Game* Fling::BaseEditor::m_Game = nullptr
| protected

## ◆ m_OwningWorld

class World* Fling::BaseEditor::m_OwningWorld = nullptr
| protected

The documentation for this class was generated from the following file:

- FlingEngine/Editor/inc/BaseEditor.h